Index: CKEditor/trunk/_source/lang/_translationstatus.txt
===================================================================
--- CKEditor/trunk/_source/lang/_translationstatus.txt	(revision 4046)
+++ CKEditor/trunk/_source/lang/_translationstatus.txt	(revision 4047)
@@ -57,3 +57,3 @@
 vi.js      Found: 435 Missing: 0
 zh-cn.js   Found: 435 Missing: 0
-zh.js      Found: 327 Missing: 108
+zh.js      Found: 435 Missing: 0
Index: CKEditor/trunk/_source/lang/zh-cn.js
===================================================================
--- CKEditor/trunk/_source/lang/zh-cn.js	(revision 4046)
+++ CKEditor/trunk/_source/lang/zh-cn.js	(revision 4047)
@@ -667,5 +667,5 @@
 		anchor : '锚点',
 		flash : 'Flash',
-		div : 'DIV',
+		div : '分页',
 		unknown : '位置对象'
 	},
Index: CKEditor/trunk/_source/lang/zh.js
===================================================================
--- CKEditor/trunk/_source/lang/zh.js	(revision 4046)
+++ CKEditor/trunk/_source/lang/zh.js	(revision 4047)
@@ -32,5 +32,5 @@
 	 * of reading non-English words. So be careful while translating it.
 	 */
-	editorTitle		: 'Rich text editor, %1', // MISSING
+	editorTitle		: '文書處理器, %1',
 
 	// Toolbar buttons without dialogs.
@@ -91,10 +91,10 @@
 		generalTab		: '一般',
 		advancedTab		: '進階',
-		validateNumberFailed	: 'This value is not a number.', // MISSING
-		confirmNewPage	: 'Any unsaved changes to this content will be lost. Are you sure you want to load new page?', // MISSING
-		confirmCancel	: 'Some of the options have been changed. Are you sure to close the dialog?', // MISSING
+		validateNumberFailed	: '需要輸入數字格式',
+		confirmNewPage	: '現存的修改尚未儲存，要開新檔案？',
+		confirmCancel	: '部份選項尚未儲存，要關閉對話盒？',
 
 		// Put the voice-only part of the label in the span.
-		unavailable		: '%1<span class="cke_accessibility">, unavailable</span>' // MISSING
+		unavailable		: '%1<span class="cke_accessibility">, 已關閉</span>'
 	},
 
@@ -130,5 +130,5 @@
 		targetPopupName	: '快顯視窗名稱',
 		popupFeatures	: '快顯視窗屬性',
-		popupResizable	: 'Resizable', // MISSING
+		popupResizable	: '可縮放',
 		popupStatusBar	: '狀態列',
 		popupLocationBar	: '網址列',
@@ -142,5 +142,5 @@
 		popupHeight		: '高',
 		popupTop		: '右',
-		id				: 'Id', // MISSING
+		id				: 'ID',
 		langDir			: '語言方向',
 		langDirNotSet	: '<尚未設定>',
@@ -188,7 +188,7 @@
 		matchCase			: '大小寫須相符',
 		matchWord			: '全字相符',
-		matchCyclic			: 'Match cyclic', // MISSING
+		matchCyclic			: '循環搜索',
 		replaceAll			: '全部取代',
-		replaceSuccessMsg	: '%1 occurrence(s) replaced.' // MISSING
+		replaceSuccessMsg	: '共完成 %1 次取代'
 	},
 
@@ -216,16 +216,16 @@
 		caption		: '標題',
 		summary		: '摘要',
-		headers		: 'Headers', // MISSING
-		headersNone		: 'None', // MISSING
-		headersColumn	: 'First column', // MISSING
-		headersRow		: 'First Row', // MISSING
-		headersBoth		: 'Both', // MISSING
-		invalidRows		: 'Number of rows must be a number greater than 0.', // MISSING
-		invalidCols		: 'Number of columns must be a number greater than 0.', // MISSING
-		invalidBorder	: 'Border size must be a number.', // MISSING
-		invalidWidth	: 'Table width must be a number.', // MISSING
-		invalidHeight	: 'Table height must be a number.', // MISSING
-		invalidCellSpacing	: 'Cell spacing must be a number.', // MISSING
-		invalidCellPadding	: 'Cell padding must be a number.', // MISSING
+		headers		: '標題',
+		headersNone		: '無標題',
+		headersColumn	: '第一欄',
+		headersRow		: '第一列',
+		headersBoth		: '第一欄和第一列',
+		invalidRows		: '必須有一或更多的列',
+		invalidCols		: '必須有一或更多的欄',
+		invalidBorder	: '邊框大小必須為數字格式',
+		invalidWidth	: '表格寬度必須為數字格式',
+		invalidHeight	: '表格高度必須為數字格式',
+		invalidCellSpacing	: '儲存格間距必須為數字格式',
+		invalidCellPadding	: '儲存格內距必須為數字格式',
 
 		cell :
@@ -240,25 +240,25 @@
 			splitHorizontal	: '橫向分割儲存格',
 			splitVertical	: '縱向分割儲存格',
-			title			: 'Cell Properties', // MISSING
-			cellType		: 'Cell Type', // MISSING
-			rowSpan			: 'Rows Span', // MISSING
-			colSpan			: 'Columns Span', // MISSING
-			wordWrap		: 'Word Wrap', // MISSING
-			hAlign			: 'Horizontal Alignment', // MISSING
-			vAlign			: 'Vertical Alignment', // MISSING
-			alignTop		: 'Top', // MISSING
-			alignMiddle		: 'Middle', // MISSING
-			alignBottom		: 'Bottom', // MISSING
-			alignBaseline	: 'Baseline', // MISSING
-			bgColor			: 'Background Color', // MISSING
-			borderColor		: 'Border Color', // MISSING
-			data			: 'Data', // MISSING
-			header			: 'Header', // MISSING
-			yes				: 'Yes', // MISSING
-			no				: 'No', // MISSING
-			invalidWidth	: 'Cell width must be a number.', // MISSING
-			invalidHeight	: 'Cell height must be a number.', // MISSING
-			invalidRowSpan	: 'Rows span must be a whole number.', // MISSING
-			invalidColSpan	: 'Columns span must be a whole number.' // MISSING
+			title			: '儲存格屬性',
+			cellType		: '儲存格類別',
+			rowSpan			: '儲存格列數',
+			colSpan			: '儲存格欄數',
+			wordWrap		: '自動換行',
+			hAlign			: '水平對齊',
+			vAlign			: '垂直對齊',
+			alignTop		: '向上對齊',
+			alignMiddle		: '置中對齊',
+			alignBottom		: '向下對齊',
+			alignBaseline	: '基線對齊',
+			bgColor			: '背景顏色',
+			borderColor		: '邊框顏色',
+			data			: '數據',
+			header			: '標題',
+			yes				: '是',
+			no				: '否',
+			invalidWidth	: '儲存格寬度必須為數字格式',
+			invalidHeight	: '儲存格高度必須為數字格式',
+			invalidRowSpan	: '儲存格列數必須為整數格式',
+			invalidColSpan	: '儲存格欄數度必須為整數格式'
 		},
 
@@ -307,5 +307,5 @@
 		action		: '動作',
 		method		: '方法',
-		encoding	: 'Encoding', // MISSING
+		encoding	: '表單編碼',
 		target		: '目標',
 		targetNotSet	: '<尚未設定>',
@@ -396,6 +396,6 @@
 		alertUrl	: '請輸入影像 URL',
 		linkTab	: '超連結',
-		button2Img	: 'Do you want to transform the selected image button on a simple image?', // MISSING
-		img2Button	: 'Do you want to transform the selected image on a image button?' // MISSING
+		button2Img	: '要把影像按鈕改成影像嗎？',
+		img2Button	: '要把影像改成影像按鈕嗎？'
 	},
 
@@ -404,18 +404,18 @@
 	{
 		properties		: 'Flash 屬性',
-		propertiesTab	: 'Properties', // MISSING
+		propertiesTab	: '屬性',
 		title		: 'Flash 屬性',
 		chkPlay		: '自動播放',
 		chkLoop		: '重複',
 		chkMenu		: '開啟選單',
-		chkFull		: 'Allow Fullscreen', // MISSING
+		chkFull		: '啟動全螢幕顯示',
  		scale		: '縮放',
 		scaleAll		: '全部顯示',
 		scaleNoBorder	: '無邊框',
 		scaleFit		: '精確符合',
-		access			: 'Script Access', // MISSING
-		accessAlways	: 'Always', // MISSING
-		accessSameDomain	: 'Same domain', // MISSING
-		accessNever	: 'Never', // MISSING
+		access			: '允許腳本訪問',
+		accessAlways	: '永遠',
+		accessSameDomain	: '相同域名',
+		accessNever	: '永不',
 		align		: '對齊',
 		alignLeft	: '靠左對齊',
@@ -428,16 +428,16 @@
 		alignTextTop	: '文字上方',
 		alignTop	: '靠上對齊',
-		quality		: 'Quality', // MISSING
-		qualityBest		 : 'Best', // MISSING
-		qualityHigh		 : 'High', // MISSING
-		qualityAutoHigh	 : 'Auto High', // MISSING
-		qualityMedium	 : 'Medium', // MISSING
-		qualityAutoLow	 : 'Auto Low', // MISSING
-		qualityLow		 : 'Low', // MISSING
-		windowModeWindow	 : 'Window', // MISSING
-		windowModeOpaque	 : 'Opaque', // MISSING
-		windowModeTransparent	 : 'Transparent', // MISSING
-		windowMode	: 'Window mode', // MISSING
-		flashvars	: 'Variables for Flash', // MISSING
+		quality		: '質素',
+		qualityBest		 : '最好',
+		qualityHigh		 : '高',
+		qualityAutoHigh	 : '高（自動）',
+		qualityMedium	 : '中（自動）',
+		qualityAutoLow	 : '低（自動）',
+		qualityLow		 : '低',
+		windowModeWindow	 : '視窗',
+		windowModeOpaque	 : '不透明',
+		windowModeTransparent	 : '透明',
+		windowMode	: '視窗模式',
+		flashvars	: 'Flash 變數',
 		bgcolor	: '背景顏色',
 		width	: '寬度',
@@ -446,8 +446,8 @@
 		vSpace	: '垂直距離',
 		validateSrc : '請輸入欲連結的 URL',
-		validateWidth : 'Width must be a number.', // MISSING
-		validateHeight : 'Height must be a number.', // MISSING
-		validateHSpace : 'HSpace must be a number.', // MISSING
-		validateVSpace : 'VSpace must be a number.' // MISSING
+		validateWidth : '寬度必須為數字格式',
+		validateHeight : '高度必須為數字格式',
+		validateHSpace : '水平間距必須為數字格式',
+		validateVSpace : '垂直間距必須為數字格式'
 	},
 
@@ -456,7 +456,7 @@
 	{
 		toolbar			: '拼字檢查',
-		title			: 'Spell Check', // MISSING
-		notAvailable	: 'Sorry, but service is unavailable now.', // MISSING
-		errorLoading	: 'Error loading application service host: %s.', // MISSING
+		title			: '拼字檢查',
+		notAvailable	: '抱歉，服務目前暫不可用',
+		errorLoading	: '無法聯系侍服器: %s.',
 		notInDic		: '不在字典中',
 		changeTo		: '更改為',
@@ -483,5 +483,5 @@
 	elementsPath :
 	{
-		eleTitle : '%1 element' // MISSING
+		eleTitle : '%1 元素'
 	},
 
@@ -539,9 +539,9 @@
 	{
 		label : '樣式',
-		voiceLabel : 'Styles', // MISSING
-		panelVoiceLabel : 'Select a style', // MISSING
-		panelTitle1 : 'Block Styles', // MISSING
-		panelTitle2 : 'Inline Styles', // MISSING
-		panelTitle3 : 'Object Styles' // MISSING
+		voiceLabel : '樣式',
+		panelVoiceLabel : '選擇樣式',
+		panelTitle1 : '塊級元素樣式',
+		panelTitle2 : '內聯元素樣式',
+		panelTitle3 : '物件元素樣式'
 	},
 
@@ -549,7 +549,7 @@
 	{
 		label : '格式',
-		voiceLabel : 'Format', // MISSING
+		voiceLabel : '格式',
 		panelTitle : '格式',
-		panelVoiceLabel : 'Select a paragraph format', // MISSING
+		panelVoiceLabel : '選擇段落格式',
 
 		tag_p : '一般',
@@ -568,7 +568,7 @@
 	{
 		label : '字體',
-		voiceLabel : 'Font', // MISSING
+		voiceLabel : '字體',
 		panelTitle : '字體',
-		panelVoiceLabel : 'Select a font' // MISSING
+		panelVoiceLabel : '選擇字體'
 	},
 
@@ -576,7 +576,7 @@
 	{
 		label : '大小',
-		voiceLabel : 'Font Size', // MISSING
+		voiceLabel : '文字大小',
 		panelTitle : '大小',
-		panelVoiceLabel : 'Select a font size' // MISSING
+		panelVoiceLabel : '選擇文字大小'
 	},
 
@@ -635,40 +635,40 @@
 	scayt :
 	{
-		title : 'Spell Check As You Type', // MISSING
-		enable : 'Enable SCAYT', // MISSING
-		disable : 'Disable SCAYT', // MISSING
-		about : 'About SCAYT', // MISSING
-		toggle : 'Toggle SCAYT', // MISSING
-		options : 'Options', // MISSING
-		langs : 'Languages', // MISSING
-		moreSuggestions : 'More suggestions', // MISSING
-		ignore : 'Ignore', // MISSING
-		ignoreAll : 'Ignore All', // MISSING
-		addWord : 'Add Word', // MISSING
-		emptyDic : 'Dictionary name should not be empty.', // MISSING
-		optionsTab : 'Options', // MISSING
-		languagesTab : 'Languages', // MISSING
-		dictionariesTab : 'Dictionaries', // MISSING
-		aboutTab : 'About' // MISSING
+		title : '即時拼寫檢查',
+		enable : '啟用即時拼寫檢查',
+		disable : '關閉即時拼寫檢查',
+		about : '關於即時拼寫檢查',
+		toggle : '啟用／關閉即時拼寫檢查',
+		options : '選項',
+		langs : '語言',
+		moreSuggestions : '更多拼寫建議',
+		ignore : '忽略',
+		ignoreAll : '全部忽略',
+		addWord : '添加單詞',
+		emptyDic : '字典名不應為空.',
+		optionsTab : '選項',
+		languagesTab : '語言',
+		dictionariesTab : '字典',
+		aboutTab : '關於'
 	},
 
 	about :
 	{
-		title : 'About CKEditor', // MISSING
-		dlgTitle : 'About CKEditor', // MISSING
-		moreInfo : 'For licensing information please visit our web site:', // MISSING
-		copy : 'Copyright &copy; $1. All rights reserved.' // MISSING
-	},
-
-	maximize : 'Maximize', // MISSING
+		title : '關於 CKEditor',
+		dlgTitle : '關於 CKEditor',
+		moreInfo : '訪問我們的網站以獲取更多關於協議的信息',
+		copy : 'Copyright &copy; $1. All rights reserved.'
+	},
+
+	maximize : '最大化',
 
 	fakeobjects :
 	{
-		anchor : 'Anchor', // MISSING
-		flash : 'Flash Animation', // MISSING
-		div : 'Page Break', // MISSING
-		unknown : 'Unknown Object' // MISSING
-	},
-
-	resize : 'Drag to resize' // MISSING
+		anchor : '錨點',
+		flash : 'Flash 動畫',
+		div : '分頁',
+		unknown : '不明物件'
+	},
+
+	resize : '拖拽改變大小'
 };